//+------------------------------------------------------------------+
//|                                                   VininI_AAA.mq4 |
//|                                Copyright  2010, Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev"
#property link      "vinin.ucoz.ru"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Red


extern int     PRICE_MA=PRICE_CLOSE;

extern string  S1="   ";
extern int     K1=1;
extern int     PERIOD_MA1= 8;
extern int     MODE_MA1=1;  // MODE_SMA 0    
                            // MODE_EMA 1    
                            // MODE_SMMA 2    
                            // MODE_LWMA 3 -   
extern int     K2=1;
extern int     PERIOD_MA2=16;
extern int     MODE_MA2=1;  // MODE_SMA 0    
                            // MODE_EMA 1    
                            // MODE_SMMA 2    
                            // MODE_LWMA 3 -   

extern string  S2="   ";
extern int     PERIOD_MA3= 4;
extern int     MODE_MA3=0;  // MODE_SMA 0    
                            // MODE_EMA 1    
                            // MODE_SMMA 2    
                            // MODE_LWMA 3 -   
extern string  S3="    ()";
extern int CountBar1 =50;
extern double pr1= 0.2;


double MA[];
double MA_UP[];
double MA_DN[];
double MA_UP1[];
double MA_DN1[];

double Vector[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {

   IndicatorBuffers(4);
   SetIndexBuffer(0,MA);      SetIndexStyle(0, DRAW_LINE);   SetIndexLabel(0,"MA");   
   SetIndexBuffer(1,MA_UP);   SetIndexStyle(1, DRAW_LINE);   SetIndexLabel(1,"UP");   
   SetIndexBuffer(2,MA_DN);   SetIndexStyle(2, DRAW_LINE);   SetIndexLabel(2,"DN");   

   SetIndexBuffer(3,Vector);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   if (K1+K2==0) return(0);
   static int dir=0;
   int    counted_bars=IndicatorCounted();
   int i, limit1=Bars-counted_bars-1;
   int limit2=limit1;
   int limit3=limit2;
   
   if (counted_bars==0) {
      limit1=Bars-MathMax(PERIOD_MA1,PERIOD_MA2)-1;
      limit2=limit1-PERIOD_MA3;
      limit3=limit2-CountBar1;
   }
   for (i=limit1;i>=0;i--)  
      Vector[i]=(K1*iMA(NULL,0,PERIOD_MA1,0,MODE_MA1,PRICE_MA,i) +K2*iMA(NULL,0,PERIOD_MA2,0,MODE_MA2,PRICE_MA,i))/(K1+K2);
   for (i=limit2;i>=0;i--)  {
      MA[i]=iMAOnArray(Vector, 0, PERIOD_MA3, 0, MODE_MA3, i);
   }
   for (i=limit3;i>=0;i--){
      MA_UP[i]=EMPTY_VALUE;
      MA_DN[i]=EMPTY_VALUE;
      int  iMax=ArrayMaximum(MA,CountBar1,i);
      int  iMin=ArrayMinimum(MA,CountBar1,i);
      double dMax=MA[iMax];
      double dMin=MA[iMin];
      
      double dCur=(dMax-MA[i])/(dMax-dMin);
      if (dCur>(1.0-pr1)) dir=1;
      else if (dCur<pr1) dir=-1;
      else dir=0;
      
      if (dir==-1) {MA_UP[i]=MA[i];MA_UP[i+1]=MA[i+1];}
      if (dir== 1) {MA_DN[i]=MA[i];MA_DN[i+1]=MA[i+1];}
   
   }
   
   
   
   return(0);
  }
//+------------------------------------------------------------------+

